=== debian/changelog ===
tetragon (1.5.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.5.0

 -- Sophie Brun <sophie@kali.org>  Wed, 06 Aug 2025 16:19:27 +0200

tetragon (1.4.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.4.0

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 26 Mar 2025 09:26:26 +0100

tetragon (1.3.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.3.0

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 17 Dec 2024 11:51:59 +0100

tetragon (1.2.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.2.1

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 28 Nov 2024 11:47:33 +0100

tetragon (1.2.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.2.0

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 10 Sep 2024 11:40:06 +0200

tetragon (1.1.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.1.0
  * Update debian/copyright
  * Fix debian/rules for new usptream version

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 14 May 2024 13:51:22 +0200

tetragon (1.0.3-0kali1) kali-dev; urgency=medium

  * New upstream version 1.0.3

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 17 Apr 2024 15:38:37 +0200

tetragon (1.0.2-0kali1) kali-dev; urgency=medium

  * New upstream version 1.0.2

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 25 Jan 2024 17:15:28 +0100

tetragon (1.0.1-0kali1) kali-dev; urgency=medium

  * New upstream version 1.0.1

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 08 Jan 2024 17:02:26 +0100

tetragon (1.0.0-0kali1) kali-dev; urgency=medium

  * New upstream version 1.0.0

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 02 Nov 2023 16:09:34 +0100

tetragon (0.11.0-0kali1) kali-dev; urgency=medium

  * d/watch: Ignore pre release
  * New upstream version 0.11.0
  * Update debian/copyright

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 07 Sep 2023 15:14:02 +0200
