=== debian/control ===
Source: tetragon
Section: misc
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 bash-completion,
 ca-certificates,
 clang,
 bpftool,
 llvm,
 docker.io,
 golang-any,
 golang-google-grpc-dev,
 golang-google-protobuf-dev,
 golang-github-sirupsen-logrus-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spf13-viper-dev,
 libcap-dev,
 libelf-dev
Standards-Version: 4.6.2
Homepage: https://github.com/cilium/tetragon
Vcs-Browser: https://gitlab.com/kalilinux/packages/tetragon
Vcs-Git: https://gitlab.com/kalilinux/packages/tetragon.git
XS-Go-Import-Path: github.com/cilium/tetragon

Package: tetragon
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 bpftool
Built-Using: ${misc:Built-Using}
Description: eBPF-based Security Observability and Runtime Enforcement (tetra CLI)
 Cilium’s new Tetragon component enables powerful realtime, eBPF-based Security
 Observability and Runtime Enforcement.
 .
 Tetragon detects and is able to react to security-significant events, such as:
    - Process execution events
    - System call activity
    - I/O activity including network & file access
 .
 When used in a Kubernetes environment, Tetragon is Kubernetes-aware - that is,
 it understands Kubernetes identities such as namespaces, pods and so-on - so
 that security event detection can be configured in relation to individual
 workloads.
 .
 This package contains the tool tetra CLI.
