=== debian/tests/control ===
Test-Command: tetra -h
Restrictions: superficial, allow-stderr
